// FOOIMPL.H : Declaration of the TFooImpl

#ifndef FooImplH
#define FooImplH

#include "COMServer_TLB.H"


/////////////////////////////////////////////////////////////////////////////
// TFooImpl     Implements IFoo, default interface of Foo
// ThreadingModel : Apartment
// Dual Interface : FALSE
// Event Support  : FALSE
// Default ProgID : COMServer.Foo
// Description    : The Foo object
/////////////////////////////////////////////////////////////////////////////
class ATL_NO_VTABLE TFooImpl : 
  public CComObjectRootEx<CComSingleThreadModel>,
  public CComCoClass<TFooImpl, &CLSID_Foo>,
  public IFoo
{
public:
  TFooImpl()
  {
  }

  // Data used when registering Object 
  //
  DECLARE_THREADING_MODEL(otApartment);
  DECLARE_PROGID("COMServer.Foo");
  DECLARE_DESCRIPTION("The Foo object");

  // Function invoked to (un)register object
  //
  static HRESULT WINAPI UpdateRegistry(BOOL bRegister)
  {
    TTypedComServerRegistrarT<TFooImpl> 
    regObj(GetObjectCLSID(), GetProgID(), GetDescription());
    return regObj.UpdateRegistry(bRegister);
  }


BEGIN_COM_MAP(TFooImpl)
  COM_INTERFACE_ENTRY(IFoo)
END_COM_MAP()

// IFoo
public:
 
  STDMETHOD(get_MachineName(BSTR* Value));
  STDMETHOD(get_UserName(BSTR* Value));
};

#endif //FooImplH
